diff -r 29b0b4245d06 pci/ac97/ac97_patch.c
--- a/pci/ac97/ac97_patch.c	Thu Feb 22 16:07:21 2007 +0100
+++ b/pci/ac97/ac97_patch.c	Fri Feb 23 16:23:36 2007 -0800
@@ -3273,8 +3273,28 @@ static int patch_vt1616(struct snd_ac97 
 /*
  * VT1617A codec
  */
+
+static const struct snd_kcontrol_new snd_ac97_controls_vt1617a[] = {
+  AC97_SINGLE("Center/LFE Exchange",   0x5a,  8, 1, 0),
+  /*
+   * These are used to enable/disable surround sound on motherboards
+   * that have 3 bidirectional analog jacks
+   */
+  AC97_SINGLE("Smart 5.1 Control A", 0x20,  8, 1, 0),
+  AC97_SINGLE("Smart 5.1 Control B", 0x7a, 15, 1, 0),
+  AC97_SINGLE("Smart 5.1 Control C", 0x7a, 14, 1, 0)
+};
+
 static int patch_vt1617a(struct snd_ac97 * ac97)
 {
+        /* instantiate our specific controls, we choose to continue in the event of failure
+	   because we wish to allow the other actions to continue */
+
+	int err = 0;
+
+	err = patch_build_controls(ac97, &snd_ac97_controls_vt1617a[0],
+				   ARRAY_SIZE(snd_ac97_controls_vt1617a));
+
 	/* bring analog power consumption to normal, like WinXP driver
 	 * for EPIA SP
 	 */
@@ -3282,7 +3302,7 @@ static int patch_vt1617a(struct snd_ac97
 	ac97->ext_id |= AC97_EI_SPDIF;	/* force the detection of spdif */
 	ac97->rates[AC97_RATES_SPDIF] = SNDRV_PCM_RATE_44100 | SNDRV_PCM_RATE_48000;
 	ac97->build_ops = &patch_vt1616_ops;
-	return 0;
+	return err;
 }
 
 /*
